unit SozBuchung;
	(*
	Programm Sozialpakt, Version A, vereinfacht;
	Autor Carsten Thumulla August 2006;
	http://Thumulla.com
	Die Entfernung dieser Lizenzinformation ist untersagt.
	Das Programm unterliegt der GPL gnu public license.
	*)

// VCL ist standardmig eingeschaltet
//{$DEFINE CLX} // Qt fr Windows und Linux

// Im Projekt mu Forms fr die VCL und QForms fr die CLX stehen.

// An dfm (VCL) oder xfm (CLX) denken, beim Editieren von Formularen.

interface

uses
	SysUtils, Types, Classes, Variants, IniFiles, DateUtils, Math, StrUtils,
{$IFDEF CLX}
	QTypes, QGraphics, QControls, QForms, QDialogs, QStdCtrls, QExtCtrls, QComCtrls, Qt;
{$ELSE}
	Graphics, Controls, Forms, Dialogs, StdCtrls, ExtCtrls, ComCtrls, Windows;
{$ENDIF}

const
	copyright = 'Carsten Thumulla 2006 GPL http://Thumulla.com';

type
	TSozBuchungForm 									= class(TForm)
		Panel														: TPanel;
		Panel1													: TPanel;
		Panel2													: TPanel;
		Panel3													: TPanel;
		Panel4													: TPanel;
		PageControl1										: TPageControl;
		TabSheet1												: TTabSheet;
		TabSheet2												: TTabSheet;
		TabSheet3												: TTabSheet;
		CBEinTeilhaber									: TComboBox;
		CBAusTeilhaber									: TComboBox;
		EdEinBetrag											: TEdit;
		EdAusBetrag											: TEdit;
		EdBuchMonat											: TEdit;
		LabKassenbestand								: TLabel;
		LabEinBuchungen									: TLabel;
		LabAusBuchungen									: TLabel;
		LabSozialanteil									: TLabel;
		LabEigenanteil									: TLabel;
		LabSozialanteilAbs							: TLabel;
		LabEigenanteilAbs								: TLabel;
		Label1													: TLabel;
		Label2													: TLabel;
		Label3													: TLabel;
		Label4													: TLabel;
		Label5													: TLabel;
		Label6													: TLabel;
		Label7													: TLabel;
		Label8													: TLabel;
		Label9													: TLabel;
		Label10													: TLabel;
		Label11													: TLabel;
		Label13													: TLabel;
		BtnEinzahlen										: TButton;
		BtnAuszahlen										: TButton;
		BtnNeu													: TButton;
		Button2													: TButton;
		Button3													: TButton;
		BtnAuto													: TButton;
		OpenDialog1											: TOpenDialog;

		// Formularfunktionen
		procedure FormCreate(Sender: TObject);
		procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
		procedure Anzeige;
		procedure EdAusBetragChange(Sender: TObject);
		procedure FormPaint(Sender: TObject);

		// Formularfunktionen Knpfe
		procedure BtnEinzahlenClick(Sender: TObject);
		procedure BtnAuszahlenClick(Sender: TObject);
		procedure BtnMonatsendeClick(Sender: TObject);
		procedure BtnNeuClick(Sender: TObject);
		procedure BtnAutoClick(Sender: TObject);
		procedure BtnCloseClick(Sender: TObject);

		// Formularfunktionen Tasten
		procedure FormKeyDown(Sender: TObject; var Key: Word;	Shift: TShiftState);

		// Dateihandhabung
		procedure KassendateiAuf(JahrMonat : String; Datum : TDateTime);

		// Buchungsfunktionen / spter Modul
		procedure PaktNeu(Datum : TDateTime);
		procedure KassenEinzahlung(JahrMonat : String; Teilhaber : String; Betrag : Currency; Datum : TDateTime);
		procedure KassenAuszahlung(JahrMonat : String; Teilhaber : String; Betrag, EigenanteilAbs : Currency; Datum : TDateTime);
		procedure TeilhaberEinzahlung(Teilhaber : TFileName; Betrag : Currency; JahrMonat : String; Datum : TDateTime);
		procedure TeilhaberAuszahlung(Teilhaber : TFileName; Betrag : Currency; Datum : TDateTime);
		procedure Anwaltshonorare(JahrMonat : String; Datum : TDateTime);
		procedure Monatsabschluss(JahrMonat : String; Datum : TDateTime);

		// Kernfunktionen / spter Modul
		function  BerechneAbsolutanteile(
			Rechnungsbetrag, SozialanteilRel : Currency;
			out SozialanteilAbs, EigenanteilAbs : Currency) : Boolean;

		// Speicherfunktionen / spter Datenmodul
		function TeilhaberExistiert(Name : String) : Boolean;

		// Automatischer Test / Simulation
		procedure Autobuchen(SteuerdateiName : TFileName);

	private
	public
	end;

var
	SozBuchungForm										: TSozBuchungForm;

implementation

const
	// diese Dateien sollen am Anfang des Verzeichnisses stehen / 'A_'
	CNameSozialpaktdatei							= 'A_Sozialpakt'; 			// Name der Hauptdatei mit Startdaten, aktuellen Daten und Monatshistorie
	CNameKassendatei                  = 'A_Kassendaten'; 			// Name der aktuellen Kassendatei + Monatskennung
	CNameAnwaltshonorardatei 					= 'A_Anwaltshonorare'; 	// Name der Abrechnung der Anwaltshonorare + Monatskennung

	CDateiendung											= '.soz'; 							// Dateiendung aller Buchungsdateien
	CLesefehler												= Low(Integer); // -999999; // dieser Ausdruck wird zurckgegeben, wenn ein Lesefehler in der Datei auftrat
	CSperrkennung											= 'ABGESCHLOSSEN'; 			// Kassendatei abgerechnet und gesperrt

{$IFDEF CLX}
	CclNurLesen												= clDisabledBackground; // Farbe signalisiert: Wert nicht editierbar
	CKey_Return 											= Key_Return;           // Taste [ENTER]
	CKey_Q 														= Key_Q; 								// Q fr Quit
{$ELSE}
	CclNurLesen												= clInfoBk;             // Farbe signalisiert: Wert nicht editierbar
	CKey_Return 											= VK_RETURN;            // Taste [ENTER]
	CKey_Q 														= 81; 									// Q fr Quit
{$ENDIF}

	CStartReglerdaempfung             = 0.85; 		// Startdaten Reglerdmpfung Altwert in der gleitenden Mittelwertbildung

	{ TODO -octh -cdaten : Wichtungen in Startdaten und Historie }
//	CVerhaeltnisWichtung              = 0.2; // 100% // 80;   // Wichtung des Einnahmenverhltnisreglers

//	CWKassensumme											= 'Kassensumme';

var
{$IFDEF CLX}
	Hoehe, Breite											: Integer; 							// zum Festhalten der Formulargre
{$ELSE}
{$ENDIF}

	Sozialpakt												: TMemIniFile; 					// Hauptdatei mit Startdaten, aktuellen Daten und Monatshistorie
	Kassendaten												: TMemIniFile; 					// aktuelle Kassendatei
	Buchungsmonat											: String = ''; 					// Monatskennung z.B. '200608'

{$IFDEF CLX}
{$R *.xfm}
{$ELSE}
{$R *.dfm}
{$ENDIF}

// {$R *.dfm}

(***********************************************)
(*** Formularfunktionen ************************)

// FormCreate
procedure TSozBuchungForm.FormCreate(Sender: TObject);
var 	NeuerPakt						: Boolean;
begin
	{ TODO -octh -csicherheit : Sicherheitsabfrage Datum und Uhrzeit richtig }
	// Hauptdatei ffnen
	NeuerPakt := not FileExists(CNameSozialpaktdatei + CDateiendung);
	Sozialpakt := TMemIniFile.Create(CNameSozialpaktdatei + CDateiendung);

	// Voreinstellungen laden
	Buchungsmonat 					:=
		Sozialpakt.ReadString('aktuelle Daten', 'Buchungsmonat', Buchungsmonat);

	// Buchunsmonat nicht editierbar
	EdBuchMonat.Color       := CclNurLesen;
	EdBuchMonat.Text				:= Buchungsmonat;
	EdBuchMonat.ReadOnly		:= True;

	// feste Einzahlung
	EdEinBetrag.Color				:= CclNurLesen;
	EdEinBetrag.Text				:=
		FloatToStr(Sozialpakt.ReadFloat('aktuelle Daten', 'Beitrag', 100));
	EdEinBetrag.ReadOnly		:= True;

	// Aussehen des Formulars
{$IFDEF CLX}
	Self.Width 							:= Panel.Width;
	Breite									:= Panel.Width;
	Self.Height							:= Panel.Height;
	Hoehe 									:= Panel.Height;
	Panel.Anchors 					:= [akLeft, akTop, akRight, akBottom];
	PageControl1.TabWidth		:= 200;
	PageControl1.ActivePage := TabSheet1;
{$ELSE}
	PageControl1.TabWidth		:= 195;
	PageControl1.ActivePage := TabSheet1;
	AutoSize 								:= True;
{$ENDIF}
	Caption 								:= 'Sozialpakt Buchungsprogramm ' + copyright;
	BtnNeu.Enabled 					:= NeuerPakt;

	// Kassendatei ffnen
	if not NeuerPakt then KassendateiAuf(Buchungsmonat, Date);

	Anzeige;
end;

// Funktionen beim Schlieen des Programmes
procedure TSozBuchungForm.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
	if Assigned(Sozialpakt) then Sozialpakt.Free;
	if Assigned(Kassendaten) then Kassendaten.Free;
end;

// Formularansicht aktualisieren
procedure TSozBuchungForm.Anzeige;
var 	offen 		: Boolean;
begin
	offen := FileExists(CNameSozialpaktdatei + CDateiendung);
	BtnEinzahlen.Enabled := offen;
	Button2.Enabled := offen;
	BtnAuszahlen.Enabled := offen;
	EdBuchMonat.Text				:= Buchungsmonat;
	BtnNeu.Enabled 					:= not FileExists(CNameSozialpaktdatei + CDateiendung);
	BtnAuto.Enabled 				:= BtnNeu.Enabled;
	if offen then begin
		LabEinBuchungen.Caption :=
			IntToStr(Kassendaten.ReadInteger('Kasse', 'Eingangsbuchungen' + Buchungsmonat, CLesefehler));
		LabAusBuchungen.Caption :=
			IntToStr(Kassendaten.ReadInteger('Kasse', 'Ausgangsbuchungen' + Buchungsmonat, CLesefehler));
		LabKassenbestand.Caption :=
			FloatToStr(Kassendaten.ReadFloat('Kasse', 'Summe', CLesefehler));
		LabSozialanteil.Caption :=
			FloatToStr(Sozialpakt.ReadFloat('aktuelle Daten', 'Sozialanteil', CLesefehler));
		LabEigenanteil.Caption 	:=
			FloatToStr(1 - Sozialpakt.ReadFloat('aktuelle Daten', 'Sozialanteil', CLesefehler));
	end;
end;

// Anzeige der absoluten Anteile an einem eingegebenen Rechnungsbetrag
procedure TSozBuchungForm.EdAusBetragChange(Sender: TObject);
var 	SozialanteilAbs			: Currency; // absoluter Anteil des Sozialpaktes an der Rechnung
			EigenanteilAbs			: Currency; // absoluter Anteil des Teilhabers an der Rechnung
			Rechnungsbetrag			: Currency; // Rechnungsbetrag des Leistungserbringers, den der Teilhaber ber den Sozialpakt zu zahlen hat
			SozialanteilRel			: Currency; // relativer Sozialanteil
begin
	LabSozialanteilAbs.Caption 				:= '---';
	LabEigenanteilAbs.Caption 				:= '---';
	if TryStrToCurr(EdAusBetrag.Text, Rechnungsbetrag) then begin
		SozialanteilRel := Sozialpakt.ReadFloat('aktuelle Daten', 'SozVerhltnisregler', CLesefehler);
		if BerechneAbsolutanteile(Rechnungsbetrag, SozialanteilRel, SozialanteilAbs, EigenanteilAbs)
		then begin
			// anzeigen
			LabSozialanteilAbs.Caption 		:= FloatToStr(SozialanteilAbs);
			LabEigenanteilAbs.Caption 		:= FloatToStr(EigenanteilAbs);
		end;
	end;
end;

// zum Festhalten der Formulargre
procedure TSozBuchungForm.FormPaint(Sender: TObject);
begin
{$IFDEF CLX}
	Self.Width 							:= Breite;
	Self.Height							:= Hoehe;
{$ELSE}
{$ENDIF}
end;

(*** Knpfe ************************************)

// Knopf Einzahlung
procedure TSozBuchungForm.BtnEinzahlenClick(Sender: TObject);
var 	Einzahlungsbetrag		: Currency; // Einzahlung des Teilhabers
begin
	if Length(CBEinTeilhaber.Text) > 3 then // Plausibilitt Teilhabername / spter Teilhaberliste
		if TryStrToCurr(EdEinBetrag.Text, Einzahlungsbetrag)
			then TeilhaberEinzahlung(CBEinTeilhaber.Text, Einzahlungsbetrag, Buchungsmonat, Date);
end;

// Knopf Auszahlung
procedure TSozBuchungForm.BtnAuszahlenClick(Sender: TObject);
var 	Rechnungsbetrag			: Currency; // Rechnungsbetrag des Leistungserbringers, den der Teilhaber ber den Sozialpakt zu zahlen hat
begin
	if not TeilhaberExistiert(CBAusTeilhaber.Text)
	then ShowMessage('Dieser Teilhaber existiert nicht.')
	else
		if TryStrToCurr(EdAusBetrag.Text, Rechnungsbetrag) then
{$IFDEF CLX}
			if Application.MessageBox
					('Ist der Eigenanteil auf dem Bankkonto?', 'Leistungsbuchung', [smbNo, smbYes]) = smbYes
				then TeilhaberAuszahlung(CBAusTeilhaber.Text, Rechnungsbetrag, Date);
{$ELSE}
			if Application.MessageBox
					('Ist der Eigenanteil auf dem Bankkonto?', 'Leistungsbuchung', MB_YESNO) = IDYES
				then TeilhaberAuszahlung(CBAusTeilhaber.Text, Rechnungsbetrag, Date);
{$ENDIF}
end;

// Knopf Einzahlungen des Monats beenden / Anwalt auszahlen
procedure TSozBuchungForm.BtnMonatsendeClick(Sender: TObject);
begin
{$IFDEF CLX}
	if Application.MessageBox
			('Den Monat ' + Buchungsmonat + ' abschlieen?', 'Monatsabschlu', [smbNo, smbYes]) = smbYes
	then Monatsabschluss(Buchungsmonat, Date);
{$ELSE}
	if Application.MessageBox
			(PAnsiChar('Den Monat ' + Buchungsmonat + ' abschlieen?'), 'Monatsabschlu', MB_YESNO) = IDYES
	then Monatsabschluss(Buchungsmonat, Date);
{$ENDIF}
	Anzeige; // Ansicht aktualisieren
end;

// Knopf neuen Pakt anlegen
// Das Verzeichnis darf keine Datei Sozialpakt enthalten, um einen neuen Pakt anzulegen.
procedure TSozBuchungForm.BtnNeuClick(Sender: TObject);
begin
{$IFDEF CLX}
	if Application.MessageBox
			('Neue Buchungsdateien anlegen?', 'neuer Pakt', [smbNo, smbYes]) = smbYes
	then PaktNeu(Date);
{$ELSE}
	if Application.MessageBox
			(PAnsiChar('Neue Buchungsdateien anlegen?'), 'neuer Pakt', MB_YESNO) = IDYES
	then PaktNeu(Date);
{$ENDIF}
	BtnNeu.Enabled 					:= not FileExists(CNameSozialpaktdatei + CDateiendung);
end;

// automatische Buchung
procedure TSozBuchungForm.BtnAutoClick(Sender: TObject);
begin
	if OpenDialog1.Execute then Autobuchen(OpenDialog1.FileName);
end;

// Knopf Programmende
procedure TSozBuchungForm.BtnCloseClick(Sender: TObject);
begin	Close; end;

(*** Tasten ************************************)

// Tastenbedienung
procedure TSozBuchungForm.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
	if (PageControl1.ActivePage = TabSheet1) and (Key = CKey_Return) then BtnEinzahlenClick(nil);
	if (ssCtrl in Shift) and (Key = CKey_Q) then BtnCloseClick(nil);
end;

(*** Tasten ************************************)
(*** Formularfunktionen ************************)
(***********************************************)
(*** Dateihandhabung ***************************)

// Kassendatei ffnen
procedure TSozBuchungForm.KassendateiAuf(JahrMonat : String; Datum : TDateTime);
var 	KasseNeu 						: Boolean; 	// nicht gefunden >> neu anlegen
			NameKassendatei			: String; 	// z.B. 'Kassendaten200608.ini'
			SummeVormonat				: Currency; // Summe der Vormonats
begin
	SummeVormonat						:= 0;
	NameKassendatei					:= CNameKassendatei + Buchungsmonat + CDateiendung;
	KasseNeu 								:= not FileExists(NameKassendatei);
	Kassendaten 						:= TMemIniFile.Create(NameKassendatei);

	// Wenn die Kassendatei gesperrt ist wird eine neue Kassendatei angelegt.
	if Kassendaten.ValueExists('Kopfdaten', CSperrkennung) then begin
		SummeVormonat := Kassendaten.ReadFloat('Kasse', 'Summe', 0); // CLesefehler);
		KasseNeu := True;
	end;

	// neue Kassendatei anlegen
	if KasseNeu then begin
		Kassendaten.WriteDateTime('Kopfdaten',
			'Kassendatei vom Monat ' + JahrMonat + ' erffnet am', Datum);
		Kassendaten.WriteFloat('Kopfdaten', 'Beitrag',
			Sozialpakt.ReadFloat('aktuelle Daten', 'Beitrag', CLesefehler));
		Kassendaten.WriteFloat('Kopfdaten', 'HonorarEingangsbuchung',
			Sozialpakt.ReadFloat('aktuelle Daten', 'HonorarEingangsbuchung', CLesefehler));
		Kassendaten.WriteFloat('Kopfdaten', 'HonorarAusgangsbuchung',
			Sozialpakt.ReadFloat('aktuelle Daten', 'HonorarAusgangsbuchung', CLesefehler));
		Kassendaten.WriteFloat('Kasse', 'Summe', SummeVormonat);
		Kassendaten.WriteFloat('Kasse', 'Einzahlungen', 0);
		Kassendaten.WriteFloat('Kasse', 'Eigenanteile', 0);
		Kassendaten.WriteFloat('Kasse', 'Auszahlungen', 0);
		Kassendaten.WriteInteger('Kasse', 'Eingangsbuchungen' + JahrMonat, 0);
		Kassendaten.WriteInteger('Kasse', 'Ausgangsbuchungen' + JahrMonat, 0);
	end;

	Kassendaten.UpdateFile;

	Anzeige; // Anzeige aktualisieren
end;

(*** Dateihandhabung ***************************)
(***********************************************)
(*** Buchungsfunktionen der Kasse **************)

// neuen Sozialpakt anlegen / Startdaten eintragen
procedure TSozBuchungForm.PaktNeu(Datum : TDateTime);
begin
	Buchungsmonat := IntToStr(MonthOf(Datum));
	if Length(Buchungsmonat) = 1 then Buchungsmonat := '0' + Buchungsmonat;
	Buchungsmonat := IntToStr(YearOf(Datum)) + Buchungsmonat;

	Sozialpakt.WriteDateTime('Startdaten', 'Sozialpakt begonnen am', Datum);
	Sozialpakt.WriteString('Startdaten', 'Buchungsmonat', Buchungsmonat);
	Sozialpakt.WriteFloat('Startdaten', 'Beitrag', 100);
	Sozialpakt.WriteFloat('Startdaten', 'HonorarEingangsbuchung', 0.50);
	Sozialpakt.WriteFloat('Startdaten', 'HonorarAusgangsbuchung', 2.00);
	// Sozialpakt.WriteFloat('aktuelle Daten', 'HonorarTeilhaber', 0.25);
	Sozialpakt.WriteFloat('Startdaten', 'SozVerhltnisregler', 0.50);
	Sozialpakt.WriteFloat('Startdaten', 'SozWichtung', CStartReglerdaempfung);
	{ TODO -octh -cFile Sozialpakt : Startdaten spter in aktuelle Daten kopieren. }
	Sozialpakt.WriteString('aktuelle Daten', 'Buchungsmonat', Buchungsmonat);
	Sozialpakt.WriteFloat('aktuelle Daten', 'Beitrag', 100);
	Sozialpakt.WriteFloat('aktuelle Daten', 'HonorarEingangsbuchung', 0.50);
	Sozialpakt.WriteFloat('aktuelle Daten', 'HonorarAusgangsbuchung', 2.00);
	// Sozialpakt.WriteFloat('aktuelle Daten', 'HonorarTeilhaber', 0.25);
	Sozialpakt.WriteFloat('aktuelle Daten', 'SozVerhltnisregler', 0.50);

	// cth20061105
	//Sozialpakt.WriteFloat('aktuelle Daten', 'Grundbetragsregler', 0.50);

	Sozialpakt.WriteFloat('aktuelle Daten', 'Sozialanteil', 0.50); // noch errechnen
	Sozialpakt.WriteFloat('aktuelle Daten', 'SozWichtung', CStartReglerdaempfung);
	Sozialpakt.UpdateFile;

	if FileExists(CNameSozialpaktdatei + CDateiendung) then
	begin
		Buchungsmonat 				:=
			Sozialpakt.ReadString('aktuelle Daten', 'Buchungsmonat', Buchungsmonat);
		KassendateiAuf(Buchungsmonat, Date);
		Anzeige; // Ansicht aktualisieren
	end;
end;

// eine Einzahlung in die Kasse buchen
procedure TSozBuchungForm.KassenEinzahlung(JahrMonat : String; Teilhaber : String; Betrag : Currency; Datum : TDateTime);
var 	zaehl								: Integer;
begin
	// Summe schreiben
	Kassendaten.WriteFloat
		('Kasse', 'Summe', Kassendaten.ReadFloat('Kasse', 'Summe', CLesefehler) + Betrag);
	Kassendaten.WriteFloat
		('Kasse', 'Einzahlungen', Kassendaten.ReadFloat('Kasse', 'Einzahlungen', CLesefehler) + Betrag);

	// Anzahl der Buchungen im Monat
	Kassendaten.WriteInteger
		('Kasse', 'Eingangsbuchungen' + JahrMonat, Kassendaten.ReadInteger('Kasse', 'Eingangsbuchungen' + JahrMonat, CLesefehler) + 1);

	// Anzahl der Buchungen heute
	if not Kassendaten.ValueExists('Kasse', 'Eingangsbuchungen' + DateToStr(Datum)) then
		Kassendaten.WriteInteger('Kasse', 'Eingangsbuchungen' + DateToStr(Datum), 0);
	Kassendaten.WriteInteger
		('Kasse', 'Eingangsbuchungen' + DateToStr(Datum), Kassendaten.ReadInteger('Kasse', 'Eingangsbuchungen' + DateToStr(Datum), CLesefehler) + 1);

	// Buchungssatz schreiben
	zaehl := 1;
	while Kassendaten.ValueExists('TeilhaberEinzahlungen ' + DateToStr(Datum), Teilhaber + '_' + IntToStr(zaehl)) do Inc(zaehl);
	Kassendaten.WriteFloat('TeilhaberEinzahlungen ' + DateToStr(Datum), Teilhaber + '_' + IntToStr(zaehl), Betrag);

	// Datei schreiben
	Kassendaten.UpdateFile;

	// Ansicht aktualisieren
	Anzeige;

end;

// eine Auszahlung aus der Kasse buchen / Leistungsbuchung
procedure TSozBuchungForm.KassenAuszahlung(JahrMonat : String; Teilhaber : String; Betrag, EigenanteilAbs : Currency; Datum : TDateTime);
var 	zaehl								: Integer;
begin
	// Kassensumme schreiben / Kassensumme enspricht dem Kontostand des Bankkontos
	Kassendaten.WriteFloat
		('Kasse', 'Summe', Kassendaten.ReadFloat('Kasse', 'Summe', CLesefehler) -
		Betrag + EigenanteilAbs);
	Kassendaten.WriteFloat
		('Kasse', 'Auszahlungen', Kassendaten.ReadFloat('Kasse', 'Auszahlungen', CLesefehler) + Betrag);
	Kassendaten.WriteFloat
		('Kasse', 'Eigenanteile', Kassendaten.ReadFloat('Kasse', 'Eigenanteile', CLesefehler) + EigenanteilAbs);

	// Anzahl der Buchungen im Monat
	Kassendaten.WriteInteger
		('Kasse', 'Ausgangsbuchungen' + JahrMonat, Kassendaten.ReadInteger('Kasse', 'Ausgangsbuchungen' + JahrMonat, CLesefehler) + 1);

	// Anzahl der Buchungen heute
	if not Kassendaten.ValueExists('Kasse', 'Ausgangsbuchungen' + DateToStr(Datum)) then
		Kassendaten.WriteInteger('Kasse', 'Ausgangsbuchungen' + DateToStr(Datum), 0);
	Kassendaten.WriteInteger
		('Kasse', 'Ausgangsbuchungen' + DateToStr(Datum), Kassendaten.ReadInteger('Kasse', 'Ausgangsbuchungen' + DateToStr(Datum), CLesefehler) + 1);

	// Buchungssatz Eigenanteil schreiben
	zaehl := 1;
	while Kassendaten.ValueExists('TeilhaberEigenanteil ' + DateToStr(Datum), Teilhaber + '_' + IntToStr(zaehl)) do Inc(zaehl);
	Kassendaten.WriteFloat('TeilhaberEigenanteil ' + DateToStr(Datum), Teilhaber + '_' + IntToStr(zaehl), EigenanteilAbs);

	// Buchungssatz Auszahlung schreiben
	zaehl := 1;
	while Kassendaten.ValueExists('TeilhaberAuszahlungen ' + DateToStr(Datum), Teilhaber + '_' + IntToStr(zaehl)) do Inc(zaehl);
	Kassendaten.WriteFloat('TeilhaberAuszahlungen ' + DateToStr(Datum), Teilhaber + '_' + IntToStr(zaehl), Betrag);

	// Datei schreiben
	Kassendaten.UpdateFile;

	// Ansicht aktualisieren
	Anzeige;

end;

// eine Einzahlung buchen
procedure TSozBuchungForm.TeilhaberEinzahlung(Teilhaber : TFileName; Betrag : Currency; JahrMonat : String; Datum : TDateTime);
var 	Teilhaberdaten 			: TMemIniFile;
			NeuerTeilhaber			: Boolean;
			zaehl								: Integer;
begin
	NeuerTeilhaber := not FileExists(Teilhaber + CDateiendung);
	Teilhaberdaten := TMemIniFile.Create(Teilhaber + CDateiendung);
	try
		if NeuerTeilhaber then begin
			Teilhaberdaten.WriteString('Kopfdaten', 'Teilhaber', Teilhaber);
			// Maske neuer Teilhaber aufmachen und weitere Daten erfassen

			Teilhaberdaten.WriteFloat('Kopfdaten', 'SummeEinz', 0);
			Teilhaberdaten.WriteFloat('Kopfdaten', 'SummeEigen', 0);
			Teilhaberdaten.WriteFloat('Kopfdaten', 'SummeAusz', 0);
			Teilhaberdaten.WriteInteger('Kopfdaten', 'AnzahlEinz', 0);
			Teilhaberdaten.WriteInteger('Kopfdaten', 'AnzahlAusz', 0);
		end;
		if Teilhaberdaten.ValueExists('Einzahlungen', JahrMonat + '_1')
		then ShowMessage('Fr diesen Tag / Monat existiert eine Buchung. Bitte die Korrektur benutzen')
		else begin
			// Summe der Einzahlungen bilden
			Teilhaberdaten.WriteFloat('Kopfdaten', 'SummeEinz', Teilhaberdaten.ReadFloat('Kopfdaten', 'SummeEinz', CLesefehler) + Betrag);

			// Anzahl der Einzahlungen bilden / Teilhabermonate
			Teilhaberdaten.WriteInteger('Kopfdaten', 'AnzahlEinz', Teilhaberdaten.ReadInteger('Kopfdaten', 'AnzahlEinz', CLesefehler) + 1);

			// Buchungssatz Einzahlung schreiben
			zaehl := 1;
			while Teilhaberdaten.ValueExists('Einzahlungen', JahrMonat + '_' + IntToStr(zaehl)) do Inc(zaehl);
			Teilhaberdaten.WriteFloat('Einzahlungen', JahrMonat + '_' + IntToStr(zaehl), Betrag);

			// in die Kasse buchen
			KassenEinzahlung(Buchungsmonat, Teilhaber, Betrag, Datum);

		end;
		Teilhaberdaten.UpdateFile;
	finally
		Teilhaberdaten.Free;
	end;
end;

// eine Auszahlung buchen / Leistungsbuchung
procedure TSozBuchungForm.TeilhaberAuszahlung(Teilhaber : TFileName;	Betrag : Currency; Datum : TDateTime);
var 	Teilhaberdaten 			: TMemIniFile;
			zaehl								: Integer;
var 	SozialanteilAbs			: Currency; // absoluter Anteil des Sozialpaktes an der Rechnung
			EigenanteilAbs			: Currency; // absoluter Anteil des Teilhabers an der Rechnung
			SozialanteilRel			: Currency; // relativer Sozialanteil
begin
	if FileExists(Teilhaber + CDateiendung) then begin
		Teilhaberdaten := TMemIniFile.Create(Teilhaber + CDateiendung);
		try
			SozialanteilRel := Sozialpakt.ReadFloat('aktuelle Daten', 'Sozialanteil', CLesefehler);
			if BerechneAbsolutanteile(Betrag, SozialanteilRel, SozialanteilAbs, EigenanteilAbs)
			then begin
				// Summe der Auszahlungen bilden
				Teilhaberdaten.WriteFloat('Kopfdaten', 'SummeAusz', Teilhaberdaten.ReadFloat('Kopfdaten', 'SummeAusz', CLesefehler) + Betrag);

				// Summe der Eigenanteile bilden
				Teilhaberdaten.WriteFloat('Kopfdaten', 'SummeEigen', Teilhaberdaten.ReadFloat('Kopfdaten', 'SummeEigen', CLesefehler) + EigenanteilAbs);

				// Anzahl der Auszahlungen bilden
				Teilhaberdaten.WriteInteger('Kopfdaten', 'AnzahlAusz', Teilhaberdaten.ReadInteger('Kopfdaten', 'AnzahlAusz', CLesefehler) + 1);

				// Buchungssatz Eigenanteil schreiben
				zaehl := 1;
				while Teilhaberdaten.ValueExists('Eigenanteil', DateToStr(Datum) + '_' + IntToStr(zaehl)) do Inc(zaehl);
				Teilhaberdaten.WriteFloat('Eigenanteil', DateToStr(Datum) + '_' + IntToStr(zaehl), EigenanteilAbs);

				// Buchungssatz Auszahlung schreiben
				zaehl := 1;
				while Teilhaberdaten.ValueExists('Auszahlungen', DateToStr(Datum) + '_' + IntToStr(zaehl)) do Inc(zaehl);
				Teilhaberdaten.WriteFloat('Auszahlungen', DateToStr(Datum) + '_' + IntToStr(zaehl), Betrag);

				// aus der Kasse buchen
				KassenAuszahlung(Buchungsmonat, Teilhaber, Betrag, EigenanteilAbs, Datum);
			end;

			Teilhaberdaten.UpdateFile;
		finally
			Teilhaberdaten.Free;
		end;
	end
	else ShowMessage('Teilhaberdatei existiert nicht');
end;

// Berechnung der Anwaltshonorare
procedure TSozBuchungForm.Anwaltshonorare(JahrMonat : String; Datum : TDateTime);
var 	Anwaltshonorare								: TMemIniFile;
			DateiName											: String;
			HonorarEingangsbuchung 				: Currency;
			HonorarAusgangsbuchung 				: Currency;
			// HonorarTeilhaber							: Currency; // Grundpauschale

begin
	DateiName := CNameAnwaltshonorardatei + JahrMonat + CDateiendung;
	Anwaltshonorare := TMemIniFile.Create(DateiName);
	try
		HonorarEingangsbuchung :=
			// Sozialpakt.ReadFloat('aktuelle Daten', 'HonorarEingangsbuchung', CLesefehler);
			Kassendaten.ReadFloat('Kopfdaten', 'HonorarEingangsbuchung', CLesefehler);
		HonorarAusgangsbuchung :=
			// Sozialpakt.ReadFloat('aktuelle Daten', 'HonorarAusgangsbuchung', CLesefehler);
			Kassendaten.ReadFloat('Kopfdaten', 'HonorarAusgangsbuchung', CLesefehler);
		// HonorarTeilhaber :=
			// Sozialpakt.ReadFloat('aktuelle Daten', 'HonorarTeilhaber', CLesefehler);

		Anwaltshonorare.WriteString('Honorarberechnung', 'Buchungsmonat', JahrMonat);
		Anwaltshonorare.WriteDateTime('Honorarberechnung', 'berechnet am', Datum);

		Anwaltshonorare.WriteFloat('Honorare', 'Honorare aus Einbuchungen', Kassendaten.ReadInteger('Kasse', 'Eingangsbuchungen' + JahrMonat, 0) * HonorarEingangsbuchung);
		Anwaltshonorare.WriteFloat('Honorare', 'Honorare aus Ausbuchungen', Kassendaten.ReadInteger('Kasse', 'Ausgangsbuchungen' + JahrMonat, 0) * HonorarAusgangsbuchung);
		// Anwaltshonorare.WriteFloat('Honorare', 'Honorare aus Grundpauschale', Kassendaten.ReadInteger('Kasse', 'Pauschale Teilhaber' + JahrMonat, 0) * HonorarTeilhaber);

		// Summe bilden
		Anwaltshonorare.WriteFloat('Honorare', 'Honorare gesamt',
			Anwaltshonorare.ReadFloat('Honorare', 'Honorare aus Einbuchungen', CLesefehler) +
			Anwaltshonorare.ReadFloat('Honorare', 'Honorare aus Ausbuchungen', CLesefehler));

		// aus Kasse buchen
		Kassendaten.WriteDateTime('Honorarbuchung', 'Datum', Datum);

		Kassendaten.WriteFloat('Honorarbuchung', 'Honorare aus Einbuchungen',
			Anwaltshonorare.ReadFloat('Honorare', 'Honorare aus Einbuchungen', CLesefehler));
		Kassendaten.WriteFloat('Honorarbuchung', 'Honorare aus Ausbuchungen',
			Anwaltshonorare.ReadFloat('Honorare', 'Honorare aus Ausbuchungen', CLesefehler));
		Kassendaten.WriteFloat('Honorarbuchung', 'Honorare gesamt',
			Anwaltshonorare.ReadFloat('Honorare', 'Honorare gesamt', CLesefehler));

		// Kassensumme
		Kassendaten.WriteFloat('Kasse', 'Summe', Kassendaten.ReadFloat('Kasse', 'Summe', CLesefehler) -
			Anwaltshonorare.ReadFloat('Honorare', 'Honorare gesamt', CLesefehler));
		Kassendaten.WriteFloat
			('Kasse', 'Auszahlungen', Kassendaten.ReadFloat('Kasse', 'Auszahlungen', CLesefehler) +
			Anwaltshonorare.ReadFloat('Honorare', 'Honorare gesamt', CLesefehler));

		// Sperrung setzen / Monatsabschlu
		// Kassendatei abschlieen
		Kassendaten.WriteDateTime('Kopfdaten', CSperrkennung, Datum);

		Kassendaten.UpdateFile;
		Anwaltshonorare.UpdateFile;
	finally
		Anwaltshonorare.Free;
	end;
end;

// aktuellen Monat beenden
procedure TSozBuchungForm.Monatsabschluss(JahrMonat : String; Datum : TDateTime);
var 	Monat								: String;
			SozialanteilNeu			: Currency; // Real;
			SozialanteilVerhReg	: Currency; // Real; // Anteil Einzahlungsverhltnisregler
			SozialanteilGrunReg	: Currency; // Real; // Anteil Grundbetragsregler
			EigenanteilRel			: Currency; // Real;
			EinzahlVerhaeltnis  : Currency; // Real;
			Kassensumme					: Currency;

	// Monatskennung weiterzhlen
	function NaechsterMonat(JahrMonat : String) : String;
	var 	Jahr, Monat				: String;
				J, M 							: Integer;
	begin
		J := StrToInt(LeftStr(JahrMonat, 4));
		M := StrToInt(MidStr(JahrMonat, 5, 2));
		if M < 12
		then Inc(M)
		else begin
			 Inc(J);
			 M := 1;
		end;
		Jahr 	:= IntToStr(J);
		Monat := IntToStr(M);
		if Length(Monat) = 1 then Monat := '0' + Monat;
		Result := Jahr + Monat;
	end;

	procedure SozialpaktWeiterrechnen;
	var 	WichtgReg2 				: Real;
	begin
		// aktuelle Daten im abgeschlossenen Monat sichern
		Monat := Sozialpakt.ReadString('aktuelle Daten', 'Buchungsmonat', 'FEHLER');
		Sozialpakt.WriteFloat('Monat' + Monat, 'Beitrag', Sozialpakt.ReadFloat('aktuelle Daten', 'Beitrag', CLesefehler));
		Sozialpakt.WriteFloat('Monat' + Monat, 'HonorarEingangsbuchung', Sozialpakt.ReadFloat('aktuelle Daten', 'HonorarEingangsbuchung', CLesefehler));
		Sozialpakt.WriteFloat('Monat' + Monat, 'HonorarAusgangsbuchung', Sozialpakt.ReadFloat('aktuelle Daten', 'HonorarAusgangsbuchung', CLesefehler));
		Sozialpakt.WriteFloat('Monat' + Monat, 'SozVerhltnisregler', Sozialpakt.ReadFloat('aktuelle Daten', 'SozVerhltnisregler', CLesefehler));

		// cth20061105
		//Sozialpakt.WriteFloat('Monat' + Monat, 'SozGrundbetragsregler', Sozialpakt.ReadFloat('aktuelle Daten', 'SozGrundbetragsregler', CLesefehler));

		Sozialpakt.WriteFloat('Monat' + Monat, 'Sozialanteil', Sozialpakt.ReadFloat('aktuelle Daten', 'Sozialanteil', CLesefehler));
		Sozialpakt.WriteFloat('Monat' + Monat, 'SozWichtung', Sozialpakt.ReadFloat('aktuelle Daten', 'SozWichtung', CLesefehler));
		Sozialpakt.WriteFloat('Monat' + Monat, 'Eingangsbuchungen', Kassendaten.ReadFloat('Kasse', 'Eingangsbuchungen' + JahrMonat, CLesefehler));
		Sozialpakt.WriteFloat('Monat' + Monat, 'Summe', Kassendaten.ReadFloat('Kasse', 'Summe', CLesefehler));

		// neue aktuelle Daten festlegen
		{ TODO -octh -ckern : in Kernfunktionen }
		// Du blickst in das Herz des Paktes, in den Hauptregler.
		// Einnahmeverhltnisregler
		if Kassendaten.ReadFloat('Kasse', 'Einzahlungen', CLesefehler) > 0 then begin
			EinzahlVerhaeltnis :=
				Kassendaten.ReadFloat('Kasse', 'Einzahlungen', CLesefehler) /
				(Kassendaten.ReadFloat('Kasse', 'Einzahlungen', CLesefehler) +
				Kassendaten.ReadFloat('Kasse', 'Auszahlungen', CLesefehler));
			SozialanteilVerhReg := EinzahlVerhaeltnis;
		end
		else ; // alten Wert bernehmen

		// Grundbetragsregler und Begrenzung
		if Sozialpakt.ReadFloat('Monat' + Monat, 'Eingangsbuchungen', CLesefehler) > 0 then
		begin
			SozialanteilGrunReg :=
				Sozialpakt.ReadFloat('Monat' + Monat, 'Summe', CLesefehler) /
				Sozialpakt.ReadFloat('Monat' + Monat, 'Eingangsbuchungen', CLesefehler) /
				500;
		end
		else ; // alten Wert bernehmen
		if SozialanteilGrunReg < 0 then SozialanteilGrunReg := 0;
		if SozialanteilGrunReg > 1 then SozialanteilGrunReg := 1;

		// Wichtung der Regleranteile
		// flieender bergang von Einnahmeverhltnis- auf Grundbetragsregelung
		WichtgReg2 := SozialanteilGrunReg * SozialanteilGrunReg * SozialanteilGrunReg; // Anteil^3 fr bestes Anregeln
		if WichtgReg2 < 0 then WichtgReg2 := 0;

		// Regleranteile addieren
		SozialanteilNeu := (1 - WichtgReg2) * SozialanteilVerhReg +	WichtgReg2 * SozialanteilGrunReg;

		// Dmpfung
		EigenanteilRel := 1 -
			Sozialpakt.ReadFloat('aktuelle Daten', 'SozWichtung', CLesefehler);

		// neuen Sozialanteil errechnen
		SozialanteilNeu :=
			Sozialpakt.ReadFloat('aktuelle Daten', 'Sozialanteil', CLesefehler) *
			Sozialpakt.ReadFloat('aktuelle Daten', 'SozWichtung', CLesefehler) +
			SozialanteilNeu * EigenanteilRel;

		// neuen Sozialanteil speichern
		Sozialpakt.WriteFloat('aktuelle Daten', 'Sozialanteil', SozialanteilNeu);
		Sozialpakt.UpdateFile;
	end;

begin

	// Buchungen kontrollieren

	// Kasse mit Konto vergleichen

	// Anwalt auszahlen
	Anwaltshonorare(Buchungsmonat, Datum); { TODO -octh -cinput : Plausibilittscheck Buchungsmonat fehlt}

	SozialpaktWeiterrechnen;

	Kassensumme := Kassendaten.ReadFloat('Kasse', 'Summe', CLesefehler);

	if Kassendaten.ReadFloat('Kasse', 'SummeVormonat', CLesefehler) <> CLesefehler
	then
		Kassendaten.WriteFloat('Kasse', 'Kassengewinn',
			Kassensumme - Kassendaten.ReadFloat('Kasse', 'SummeVormonat', CLesefehler))
	else ;

	if (Kassendaten.ReadFloat('Kasse', 'SummeVormonat', CLesefehler) <> CLesefehler) and
		 (Kassendaten.ReadFloat('Kasse', 'Eingangsbuchungen' + Buchungsmonat, CLesefehler) > 0) then
	begin
		Kassendaten.WriteFloat('Kasse', 'MittlererKassengewinn',
			Kassendaten.ReadFloat('Kasse', 'SummeVormonat', CLesefehler) /
			Kassendaten.ReadFloat('Kasse', 'Eingangsbuchungen' + Buchungsmonat, CLesefehler));
	end
	else ; // Ersatzwert schreiben

	Kassendaten.UpdateFile;

	// Monat weiterzhlen
	Buchungsmonat := NaechsterMonat(Buchungsmonat);

	// Kassendatei weiterschalten
	Kassendaten.Free;
	KassendateiAuf(Buchungsmonat, Date);
	Kassendaten.WriteFloat('Kasse', 'SummeVormonat', Kassensumme);
	Kassendaten.WriteFloat('Kasse', 'Summe', Kassensumme);

	// Sozialpakt weiterschalten
	Sozialpakt.WriteString('aktuelle Daten', 'Buchungsmonat', Buchungsmonat);
	Sozialpakt.UpdateFile;

	// SetRO und Backup

end;

(*** Buchungsfunktionen der Kasse **************)
(***********************************************)
(*** Kernfunktionen der Kasse ******************)

// absolute Anteile eines Betrages, einer Leistungsberechnung ermitteln
function TSozBuchungForm.BerechneAbsolutanteile(
	Rechnungsbetrag, SozialanteilRel : Currency;
	out SozialanteilAbs, EigenanteilAbs : Currency) : Boolean;
begin
	Result 									:= False;
	SozialanteilAbs 				:= 0;
	EigenanteilAbs 					:= 0;
	if (Rechnungsbetrag > 0) and (SozialanteilRel > 0) and (SozialanteilRel < 100)
	then begin
		SozialanteilAbs 			:= RoundTo(SozialanteilRel * Rechnungsbetrag, -2);
		EigenanteilAbs 				:= RoundTo(Rechnungsbetrag - SozialanteilAbs, -2);
		Result 								:= True;
	end;
end;

(*** Kernfunktionen der Kasse ******************)
(***********************************************)
(*** Speicherfunktionen ************************) // spter Datenmodul

function TSozBuchungForm.TeilhaberExistiert(Name : String) : Boolean;
begin
	Result := FileExists(Name + CDateiendung);
end;

(*** Speicherfunktionen ************************) // spter Datenmodul
(***********************************************)
(*** Buchungsautomatik *************************)

// automatisches Buchen zum automatischen Programmtest und zur Simulation des Regelverhaltens
procedure TSozBuchungForm.Autobuchen(SteuerdateiName : TFileName);
var 	Steuerdatei 				: TextFile;
			Kommando						: String;
			Worte								: TStringList;
			Betrag							: Currency;
			Datum								: TDateTime;

begin
	Datum := Date;
	Worte := TStringList.Create;
	try
		AssignFile(Steuerdatei, SteuerdateiName);
		Reset(Steuerdatei);
		while not eof(Steuerdatei) do begin
			ReadLn(Steuerdatei, Kommando); // Zeilen lesen
			Worte.CommaText := Kommando;
			if Worte.Count > 0 then begin
				// neuen Pakt anlegen
				if Worte[0] = 'NeuPakt' then begin
					Datum := StrToDateTime(Worte[1]);
					PaktNeu(Datum);
				end;

				// Datum setzen
				if Worte[0] = 'Datum' then Datum := StrToDateTime(Worte[1]); // Datum in Buchungsmonat fehlt

				// Einzahlung
				if Worte[0] = 'Einzahlg' then
					if Length(Worte[1]) > 3 then // Plausibilitt Teilhabername / spter Teilhaberliste
						if TryStrToCurr(Worte[2], Betrag)
							then TeilhaberEinzahlung(Worte[1], Betrag, Buchungsmonat, Datum);

				// Auszahlung
				if Worte[0] = 'Auszahlg' then
					if TeilhaberExistiert(Worte[1]) then
						if TryStrToCurr(Worte[2], Betrag) then
							TeilhaberAuszahlung(Worte[1], Betrag, Datum);

				// Monatsabschlu
				if Worte[0] = 'Monatsab' then Monatsabschluss(Worte[1], Datum);
			end;
		end;
		CloseFile(Steuerdatei);
	finally
		Worte.Free;
	end;
	Anzeige; // Ansicht aktualisieren
end;

(*** Buchungsautomatik *************************)
(***********************************************)

end.


